/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    TK_API = 258,                  /* TK_API  */
    TK_DEFENCODING = 259,          /* TK_DEFENCODING  */
    TK_PLUGIN = 260,               /* TK_PLUGIN  */
    TK_DOCSTRING = 261,            /* TK_DOCSTRING  */
    TK_DOC = 262,                  /* TK_DOC  */
    TK_EXPORTEDDOC = 263,          /* TK_EXPORTEDDOC  */
    TK_MAKEFILE = 264,             /* TK_MAKEFILE  */
    TK_ACCESSCODE = 265,           /* TK_ACCESSCODE  */
    TK_GETCODE = 266,              /* TK_GETCODE  */
    TK_SETCODE = 267,              /* TK_SETCODE  */
    TK_PREINITCODE = 268,          /* TK_PREINITCODE  */
    TK_INITCODE = 269,             /* TK_INITCODE  */
    TK_POSTINITCODE = 270,         /* TK_POSTINITCODE  */
    TK_UNITCODE = 271,             /* TK_UNITCODE  */
    TK_MODCODE = 272,              /* TK_MODCODE  */
    TK_TYPECODE = 273,             /* TK_TYPECODE  */
    TK_PREPYCODE = 274,            /* TK_PREPYCODE  */
    TK_COPYING = 275,              /* TK_COPYING  */
    TK_MAPPEDTYPE = 276,           /* TK_MAPPEDTYPE  */
    TK_CODELINE = 277,             /* TK_CODELINE  */
    TK_IF = 278,                   /* TK_IF  */
    TK_END = 279,                  /* TK_END  */
    TK_NAME = 280,                 /* TK_NAME  */
    TK_PATHNAME = 281,             /* TK_PATHNAME  */
    TK_STRING = 282,               /* TK_STRING  */
    TK_VIRTUALCATCHERCODE = 283,   /* TK_VIRTUALCATCHERCODE  */
    TK_TRAVERSECODE = 284,         /* TK_TRAVERSECODE  */
    TK_CLEARCODE = 285,            /* TK_CLEARCODE  */
    TK_GETBUFFERCODE = 286,        /* TK_GETBUFFERCODE  */
    TK_RELEASEBUFFERCODE = 287,    /* TK_RELEASEBUFFERCODE  */
    TK_READBUFFERCODE = 288,       /* TK_READBUFFERCODE  */
    TK_WRITEBUFFERCODE = 289,      /* TK_WRITEBUFFERCODE  */
    TK_SEGCOUNTCODE = 290,         /* TK_SEGCOUNTCODE  */
    TK_CHARBUFFERCODE = 291,       /* TK_CHARBUFFERCODE  */
    TK_PICKLECODE = 292,           /* TK_PICKLECODE  */
    TK_METHODCODE = 293,           /* TK_METHODCODE  */
    TK_FROMTYPE = 294,             /* TK_FROMTYPE  */
    TK_TOTYPE = 295,               /* TK_TOTYPE  */
    TK_TOSUBCLASS = 296,           /* TK_TOSUBCLASS  */
    TK_INCLUDE = 297,              /* TK_INCLUDE  */
    TK_OPTINCLUDE = 298,           /* TK_OPTINCLUDE  */
    TK_IMPORT = 299,               /* TK_IMPORT  */
    TK_EXPHEADERCODE = 300,        /* TK_EXPHEADERCODE  */
    TK_MODHEADERCODE = 301,        /* TK_MODHEADERCODE  */
    TK_TYPEHEADERCODE = 302,       /* TK_TYPEHEADERCODE  */
    TK_MODULE = 303,               /* TK_MODULE  */
    TK_CMODULE = 304,              /* TK_CMODULE  */
    TK_CONSMODULE = 305,           /* TK_CONSMODULE  */
    TK_COMPOMODULE = 306,          /* TK_COMPOMODULE  */
    TK_CLASS = 307,                /* TK_CLASS  */
    TK_STRUCT = 308,               /* TK_STRUCT  */
    TK_PUBLIC = 309,               /* TK_PUBLIC  */
    TK_PROTECTED = 310,            /* TK_PROTECTED  */
    TK_PRIVATE = 311,              /* TK_PRIVATE  */
    TK_SIGNALS = 312,              /* TK_SIGNALS  */
    TK_SIGNAL_METHOD = 313,        /* TK_SIGNAL_METHOD  */
    TK_SLOTS = 314,                /* TK_SLOTS  */
    TK_SLOT_METHOD = 315,          /* TK_SLOT_METHOD  */
    TK_BOOL = 316,                 /* TK_BOOL  */
    TK_SHORT = 317,                /* TK_SHORT  */
    TK_INT = 318,                  /* TK_INT  */
    TK_LONG = 319,                 /* TK_LONG  */
    TK_FLOAT = 320,                /* TK_FLOAT  */
    TK_DOUBLE = 321,               /* TK_DOUBLE  */
    TK_CHAR = 322,                 /* TK_CHAR  */
    TK_WCHAR_T = 323,              /* TK_WCHAR_T  */
    TK_VOID = 324,                 /* TK_VOID  */
    TK_PYOBJECT = 325,             /* TK_PYOBJECT  */
    TK_PYTUPLE = 326,              /* TK_PYTUPLE  */
    TK_PYLIST = 327,               /* TK_PYLIST  */
    TK_PYDICT = 328,               /* TK_PYDICT  */
    TK_PYCALLABLE = 329,           /* TK_PYCALLABLE  */
    TK_PYSLICE = 330,              /* TK_PYSLICE  */
    TK_PYTYPE = 331,               /* TK_PYTYPE  */
    TK_VIRTUAL = 332,              /* TK_VIRTUAL  */
    TK_ENUM = 333,                 /* TK_ENUM  */
    TK_SIGNED = 334,               /* TK_SIGNED  */
    TK_UNSIGNED = 335,             /* TK_UNSIGNED  */
    TK_SCOPE = 336,                /* TK_SCOPE  */
    TK_LOGICAL_OR = 337,           /* TK_LOGICAL_OR  */
    TK_CONST = 338,                /* TK_CONST  */
    TK_STATIC = 339,               /* TK_STATIC  */
    TK_SIPSIGNAL = 340,            /* TK_SIPSIGNAL  */
    TK_SIPSLOT = 341,              /* TK_SIPSLOT  */
    TK_SIPANYSLOT = 342,           /* TK_SIPANYSLOT  */
    TK_SIPRXCON = 343,             /* TK_SIPRXCON  */
    TK_SIPRXDIS = 344,             /* TK_SIPRXDIS  */
    TK_SIPSLOTCON = 345,           /* TK_SIPSLOTCON  */
    TK_SIPSLOTDIS = 346,           /* TK_SIPSLOTDIS  */
    TK_NUMBER = 347,               /* TK_NUMBER  */
    TK_REAL = 348,                 /* TK_REAL  */
    TK_TYPEDEF = 349,              /* TK_TYPEDEF  */
    TK_NAMESPACE = 350,            /* TK_NAMESPACE  */
    TK_TIMELINE = 351,             /* TK_TIMELINE  */
    TK_PLATFORMS = 352,            /* TK_PLATFORMS  */
    TK_FEATURE = 353,              /* TK_FEATURE  */
    TK_LICENSE = 354,              /* TK_LICENSE  */
    TK_TQCHAR = 355,               /* TK_TQCHAR  */
    TK_TRUE = 356,                 /* TK_TRUE  */
    TK_FALSE = 357,                /* TK_FALSE  */
    TK_NULL = 358,                 /* TK_NULL  */
    TK_OPERATOR = 359,             /* TK_OPERATOR  */
    TK_THROW = 360,                /* TK_THROW  */
    TK_TQOBJECT = 361,             /* TK_TQOBJECT  */
    TK_EXCEPTION = 362,            /* TK_EXCEPTION  */
    TK_RAISECODE = 363,            /* TK_RAISECODE  */
    TK_EXPLICIT = 364,             /* TK_EXPLICIT  */
    TK_TEMPLATE = 365,             /* TK_TEMPLATE  */
    TK_ELLIPSIS = 366,             /* TK_ELLIPSIS  */
    TK_DEFMETATYPE = 367,          /* TK_DEFMETATYPE  */
    TK_DEFSUPERTYPE = 368          /* TK_DEFSUPERTYPE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define TK_API 258
#define TK_DEFENCODING 259
#define TK_PLUGIN 260
#define TK_DOCSTRING 261
#define TK_DOC 262
#define TK_EXPORTEDDOC 263
#define TK_MAKEFILE 264
#define TK_ACCESSCODE 265
#define TK_GETCODE 266
#define TK_SETCODE 267
#define TK_PREINITCODE 268
#define TK_INITCODE 269
#define TK_POSTINITCODE 270
#define TK_UNITCODE 271
#define TK_MODCODE 272
#define TK_TYPECODE 273
#define TK_PREPYCODE 274
#define TK_COPYING 275
#define TK_MAPPEDTYPE 276
#define TK_CODELINE 277
#define TK_IF 278
#define TK_END 279
#define TK_NAME 280
#define TK_PATHNAME 281
#define TK_STRING 282
#define TK_VIRTUALCATCHERCODE 283
#define TK_TRAVERSECODE 284
#define TK_CLEARCODE 285
#define TK_GETBUFFERCODE 286
#define TK_RELEASEBUFFERCODE 287
#define TK_READBUFFERCODE 288
#define TK_WRITEBUFFERCODE 289
#define TK_SEGCOUNTCODE 290
#define TK_CHARBUFFERCODE 291
#define TK_PICKLECODE 292
#define TK_METHODCODE 293
#define TK_FROMTYPE 294
#define TK_TOTYPE 295
#define TK_TOSUBCLASS 296
#define TK_INCLUDE 297
#define TK_OPTINCLUDE 298
#define TK_IMPORT 299
#define TK_EXPHEADERCODE 300
#define TK_MODHEADERCODE 301
#define TK_TYPEHEADERCODE 302
#define TK_MODULE 303
#define TK_CMODULE 304
#define TK_CONSMODULE 305
#define TK_COMPOMODULE 306
#define TK_CLASS 307
#define TK_STRUCT 308
#define TK_PUBLIC 309
#define TK_PROTECTED 310
#define TK_PRIVATE 311
#define TK_SIGNALS 312
#define TK_SIGNAL_METHOD 313
#define TK_SLOTS 314
#define TK_SLOT_METHOD 315
#define TK_BOOL 316
#define TK_SHORT 317
#define TK_INT 318
#define TK_LONG 319
#define TK_FLOAT 320
#define TK_DOUBLE 321
#define TK_CHAR 322
#define TK_WCHAR_T 323
#define TK_VOID 324
#define TK_PYOBJECT 325
#define TK_PYTUPLE 326
#define TK_PYLIST 327
#define TK_PYDICT 328
#define TK_PYCALLABLE 329
#define TK_PYSLICE 330
#define TK_PYTYPE 331
#define TK_VIRTUAL 332
#define TK_ENUM 333
#define TK_SIGNED 334
#define TK_UNSIGNED 335
#define TK_SCOPE 336
#define TK_LOGICAL_OR 337
#define TK_CONST 338
#define TK_STATIC 339
#define TK_SIPSIGNAL 340
#define TK_SIPSLOT 341
#define TK_SIPANYSLOT 342
#define TK_SIPRXCON 343
#define TK_SIPRXDIS 344
#define TK_SIPSLOTCON 345
#define TK_SIPSLOTDIS 346
#define TK_NUMBER 347
#define TK_REAL 348
#define TK_TYPEDEF 349
#define TK_NAMESPACE 350
#define TK_TIMELINE 351
#define TK_PLATFORMS 352
#define TK_FEATURE 353
#define TK_LICENSE 354
#define TK_TQCHAR 355
#define TK_TRUE 356
#define TK_FALSE 357
#define TK_NULL 358
#define TK_OPERATOR 359
#define TK_THROW 360
#define TK_TQOBJECT 361
#define TK_EXCEPTION 362
#define TK_RAISECODE 363
#define TK_EXPLICIT 364
#define TK_TEMPLATE 365
#define TK_ELLIPSIS 366
#define TK_DEFMETATYPE 367
#define TK_DEFSUPERTYPE 368

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 149 "/tmp/BUILD.osstw.x86_64/trinity-sip4-tqt-4.10.5-build/trinity-sip4-tqt-14.1.4/sipgen/parser.y"

    char            qchar;
    char            *text;
    long            number;
    double          real;
    argDef          memArg;
    signatureDef    signature;
    signatureDef    *optsignature;
    throwArgs       *throwlist;
    codeBlock       *codeb;
    valueDef        value;
    valueDef        *valp;
    optFlags        optflags;
    optFlag         flag;
    scopedNameDef   *scpvalp;
    fcallDef        fcall;
    int             boolean;
    exceptionDef    exceptionbase;
    classDef        *klass;

#line 314 "parser.h"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_PARSER_H_INCLUDED  */
